select
    an.cdanimal as "cd_animal_interno_ideagri"
    , an.seriealfa as "Srie"
    , an.rgn as "RGN"
    , an.regassocraca as "RGD"
    , an.nomecompleto as "Nome"
    , grau.sigla as "Tipo"
    , an.sexo as "Sexo" 
    , (case rac.codigoraca when 1 then 'NEL' when 2 then 'GUZ' when 3 then 'GUN' when 4 then 'BRA' when 6 then 'BRN' when 7 then 'GIR' when 8 then 'TAB' when 9 then 'TAN' when 0 then 'DES' else 'OUT' end) as "Raa"
    , lpad(extract(day from an.dtnascimento),2 ,0) || '/' || lpad(extract(month from an.dtnascimento),2,0) || '/' || extract(year from an.dtnascimento) as "Data Nascimento"
    , (select otexto from sp_strreplace(pe.peso, '.', ',')) as "Peso Nascer"
    , (case when ((an.cdmae is not null) and (an.cdreproducao is not null) and (an.cdmae <> par.cdanimal))
            then rec.numero else null end) as "ID Receptora"
    , (case rac2.codigoraca when 1 then 'NEL' when 2 then 'GUZ' when 3 then 'GUN' when 4 then 'BRA' when 6 then 'BRN' when 7 then 'GIR' when 8 then 'TAB' when 9 then 'TAN' when 0 then 'DES' when 'null' then 'OUT' else null end) as "Raa Receptora"
    , (case when (cob.cdtiporeproducao <> 3) then (select otexto from sp_strreplace(pedesmae.peso, '.', ',')) else null end) as "PesoMeDesmame"

    , pai.cdanimal as cdanimal_pai_13
    , pai.numero as numero_pai_13
    , pai.nome as nome_resumido_pai_13
    , pai.nomecompleto as nome_completo_pai_13
    , pai.seriealfa as serie_alfa_pai_13
    , pai.rgn as rgn_pai_13
    , pai.regassocraca as rgd_pai_13
    , (case pai.animalrebanho when 1 then 'Sim' when 0 then 'No' else null end) as pertence_a_fazenda_pai_13
    , (case pai.tipoanimal when 'A' then 'Animal' when 'S' then 'Smen' when 'I' then 'Smen' else null end) as tipo_pai_13
    , paipai.cdanimal as cdanimal_pai_pai_09
    , paipai.numero as numero_pai_pai_09
    , paipai.nome as nome_resumido_pai_pai_09
    , paipai.nomecompleto as nome_completo_pai_pai_09
    , paipai.seriealfa as serie_alfa_pai_pai_09
    , paipai.rgn as rgn_pai_pai_09
    , paipai.regassocraca as rgd_pai_pai_09
    , (case paipai.animalrebanho when 1 then 'Sim' when 0 then 'No' else null end) as pertence_a_fazenda_pai_pai_09
    , (case paipai.tipoanimal when 'A' then 'Animal' when 'S' then 'Smen' when 'I' then 'Smen' else null end) as tipo_pai_pai_09

    , paipaipai.cdanimal as cdanimal_pai_pai_pai_01
    , paipaipai.numero as numero_pai_pai_pai_01
    , paipaipai.nome as nome_resumido_pai_pai_pai_01
    , paipaipai.nomecompleto as nome_completo_pai_pai_pai_01
    , paipaipai.seriealfa as serie_alfa_pai_pai_pai_01
    , paipaipai.rgn as rgn_pai_pai_pai_01
    , paipaipai.regassocraca as rgd_pai_pai_pai_01
    , (case paipaipai.animalrebanho when 1 then 'Sim' when 0 then 'No' else null end) as pertence_a_fazenda_pai_pai_pai_01
    , (case paipaipai.tipoanimal when 'A' then 'Animal' when 'S' then 'Smen' when 'I' then 'Smen' else null end) as tipo_pai_pai_pai_01

    , maepai.cdanimal as cdanimal_mae_pai_10
    , maepai.numero as numero_mae_pai_10
    , maepai.nome as nome_resumido_mae_pai_10
    , maepai.nomecompleto as nomecompleto_mae_pai_10
    , maepai.seriealfa as serie_alfa_mae_pai_10
    , maepai.rgn as rgn_mae_pai_10
    , maepai.regassocraca as rgd_mae_pai_10

    , maepaipai.cdanimal as cdanimal_mae_pai_pai_01
    , maepaipai.numero as numero_mae_pai_pai_01
    , maepaipai.nome as nome_resumido_mae_pai_pai_02
    , maepaipai.nomecompleto as nome_completo_mae_pai_pai_02
    , maepaipai.seriealfa as serie_alfa_mae_pai_pai_02
    , maepaipai.rgn as rgn_mae_pai_pai_02
    , maepaipai.regassocraca as rgd_mae_pai_pai_02

    , paimaepai.cdanimal as cdanimal_pai_mae_pai_03
    , paimaepai.numero as numero_pai_mae_pai_03
    , paimaepai.nome as nome_resumido_pai_mae_pai_03
    , paimaepai.nomecompleto as nome_completo_pai_mae_pai_03
    , paimaepai.seriealfa as serie_alfa_pai_mae_pai_03
    , paimaepai.rgn as rgn_pai_mae_pai_03
    , paimaepai.regassocraca as rgd_pai_mae_pai_03
    , (case paimaepai.animalrebanho when 1 then 'Sim' when 0 then 'No' else null end) as pertence_a_fazenda_pai_mae_pai_03
    , (case paimaepai.tipoanimal when 'A' then 'Animal' when 'S' then 'Smen' when 'I' then 'Smen' else null end) as tipo_pai_mae_pai_03

    , maemaepai.cdanimal as cdanimal_mae_mae_pai_04
    , maemaepai.numero as numero_mae_mae_pai_04
    , maemaepai.nome as nome_resumido_mae_mae_pai_04
    , maemaepai.nomecompleto as nome_completo_mae_mae_pai_04
    , maemaepai.seriealfa as serie_alfa_mae_mae_pai_04
    , maemaepai.rgn as rgn_mae_mae_pai_04
    , maemaepai.regassocraca as rgd_mae_mae_pai_04

    , mae.cdanimal as cdanimal_mae_14
    , mae.numero as numero_mae_14
    , mae.nome as nome_resumido_mae_14
    , mae.nomecompleto as nome_completo_mae_14
    , mae.seriealfa as serie_alfa_mae_14
    , mae.rgn as rgn_mae_14
    , mae.regassocraca as rgd_mae_14

    , paimae.cdanimal as cdanimal_pai_mae_11
    , paimae.numero as numero_pai_mae_11
    , paimae.nome as nome_resumido_pai_mae_11
    , paimae.nomecompleto as nome_completo_pai_mae_11
    , paimae.seriealfa as serie_alfa_pai_mae_11
    , paimae.rgn as rgn_pai_mae_11
    , paimae.regassocraca as rgd_pai_mae_11
    , (case paimae.animalrebanho when 1 then 'Sim' when 0 then 'No' else null end) as pertence_a_fazenda_pai_mae_11
    , (case paimae.tipoanimal when 'A' then 'Animal' when 'S' then 'Smen' when 'I' then 'Smen' else null end) as tipo_pai_mae_11

    , paipaimae.cdanimal as cdanimal_pai_pai_mae_05
    , paipaimae.numero as numero_pai_pai_mae_05
    , paipaimae.nome as nome_resumido_pai_pai_mae_05
    , paipaimae.nomecompleto as nome_completo_pai_pai_mae_05
    , paipaimae.seriealfa as serie_alfa_pai_pai_mae_05
    , paipaimae.rgn as rgn_pai_pai_mae_05
    , paipaimae.regassocraca as rgd_pai_pai_mae_05
    , (case paipaimae.animalrebanho when 1 then 'Sim' when 0 then 'No' else null end) as pertence_a_fazenda_pai_pai_mae_05
    , (case paipaimae.tipoanimal when 'A' then 'Animal' when 'S' then 'Smen' when 'I' then 'Smen' else null end) as tipo_pai_pai_mae_05

    , maepaimae.cdanimal as cdanimal_mae_pai_mae_06
    , maepaimae.numero as numero_mae_pai_mae_06
    , maepaimae.nome as nome_resumido_mae_pai_mae_06
    , maepaimae.nomecompleto as nome_completomae_pai_mae_06
    , maepaimae.seriealfa as serie_alfa_pai_mae_06
    , maepaimae.rgn as rgn_pai_mae_06
    , maepaimae.regassocraca as rgd_pai_mae_06

    , maemae.cdanimal as cdanimal_mae_mae_12
    , maemae.numero as numero_mae_mae_12
    , maemae.nome as nome_resumido_mae_mae_12
    , maemae.nomecompleto as nome_completo_mae_mae_12
    , maemae.seriealfa as serie_alfa_mae_mae_12
    , maemae.rgn as rgn_mae_mae_12
    , maemae.regassocraca as rgd_mae_mae_12

    , paimaemae.cdanimal as cdanimal_pai_mae_mae_07
    , paimaemae.numero as numero_pai_mae_mae_07
    , paimaemae.nome as nome_resumido_pai_mae_mae_07
    , paimaemae.nomecompleto as nome_completo_pai_mae_mae_07
    , paimaemae.seriealfa as serie_alfa_pai_mae_mae_07
    , paimaemae.rgn as rgn_pai_mae_mae_07
    , paimaemae.regassocraca as rgd_pai_mae_mae_07
    , (case paimaemae.animalrebanho when 1 then 'Sim' when 0 then 'No' else null end) as pertence_a_fazenda_pai_mae_mae_07
    , (case paimaemae.tipoanimal when 'A' then 'Animal' when 'S' then 'Smen' when 'I' then 'Smen' else null end) as tipo_pai_mae_mae_07

    , maemaemae.cdanimal as cdanimal_mae_mae_mae_08
    , maemaemae.numero as numero_mae_mae_mae_08
    , maemaemae.nome as nome_resumido_mae_mae_mae_08
    , maemaemae.nomecompleto as nome_completo_mae_mae_mae_08
    , maemaemae.seriealfa as serie_alfa_mae_mae_mae_08
    , maemaemae.rgn as rgn_mae_mae_mae_08
    , maemaemae.regassocraca as rgd_mae_mae_mae_08

from
    animal an
    left join animal maep on maep.cdanimal = an.cdmae
    left join graucruzamento grau on grau.cdgraucruzamento = an.cdgraucruzamento
    left join peso pe on pe.cdanimal = an.cdanimal and pe.cdtipopeso in (1,2)
    left join sp_retornaracaancp(an.cdanimal) rac on 1 = 1 and rac.codigoraca <> ''
    left join reproducao par on par.cdreproducao = an.cdreproducao
    left join reproducao cob on cob.cdreproducao =
        (select first 1 re.cdreproducao from reproducao re where re.cdanimal = par.cdanimal
                and re.cdtiporeproducao = any (select cdtiporeproducao from tiporeproducao where cdtiporeproducao <= 3)
                and re.data < par.data
                order by re.data desc)
    left join peso pedesmae on pedesmae.cdpeso =
        (select first 1 re.cdpeso from peso re where re.cdanimal = maep.cdanimal and re.dtpeso = an.dtdesmama)
    left join animal rec on rec.cdanimal = par.cdanimal and rec.cdanimal <> an.cdmae
    left join sp_retornaracaancp(rec.cdanimal) rac2 on 1 = 1 and rac2.codigoraca <> ''
    left join animal mae on mae.cdanimal = an.cdmae
    left join animal pai on pai.cdanimal = an.cdpai
    left join animal paimae on paimae.cdanimal = mae.cdpai
    left join animal maemae on maemae.cdanimal = mae.cdmae
    left join animal maepaimae on maepaimae.cdanimal = paimae.cdmae
    left join animal paipaimae on paipaimae.cdanimal = paimae.cdpai
    left join animal maemaemae on maemaemae.cdanimal = maemae.cdmae
    left join animal paimaemae on paimaemae.cdanimal = maemae.cdpai
    left join animal paipai on paipai.cdanimal = pai.cdpai
    left join animal maepai on maepai.cdanimal = pai.cdmae
    left join animal paipaipai on paipaipai.cdanimal = paipai.cdpai
    left join animal maepaipai on maepaipai.cdanimal = paipai.cdmae
    left join animal maemaepai on maemaepai.cdanimal = maepai.cdmae
    left join animal paimaepai on paimaepai.cdanimal = maepai.cdpai
where 1 = 1
 and an.dtbaixa is null
 and an.tipoanimal = 'A'
 and an.animalrebanho = '1'
--- ATENO - INFORMAR OS CDIGOS DOS SETORES DESEJADOS
 and an.cdsetor in (109, 201,208)
--- ESTA CONSULTA EST VOLTANDO APENAS NELORE E NELORE MOCHO
 and rac.codigoraca ='1'
--- and an.seriealfa in ('')
order by 2,3,1